module Rails
  module Generators
    class FinderGenerator < NamedBase
      source_root File.expand_path('templates', __dir__)
      check_class_collision suffix: 'Finder'

      class_option :parent, type: :string, desc: "The parent class for the generated finder"

      def create_finder_file
        template 'finder.rb', File.join('app/finders', class_path, "#{file_name}_finder.rb")
      end

      hook_for :test_framework

      private

      def parent_class_name
        options.fetch('parent') do
          begin
            require 'application_finder'
            ApplicationFinder
          rescue LoadError
            'Clairvoyance::Finder'
          end
        end
      end
    end
  end
end
